/*----------------------------------------------------------------------------   
 * Ŀ:

     RGB LED

 * :

     1ݷ͵õLEDʾ
	 2ָؿʼݷ͵LEDʾ
	 3͸λź

 * ȨϢ:

     (c) , 2014.

 * ʷ汾:
     2014-03-15:
       - ʼ汾 V1.0.0;

 * ˵:
     MCU:             STC15W204S
     :      	  ڲ33MHz
     չģ:  	  -
     :            Keil.C51.V9.01

 * ע:

------------------------------------------------------------------------------*/   

#include "STC15W.h"
#include "ws2812.h"
#include "intrins.h"

//-------------------------------------------------------------------------------
//ӳ:IO_Init(void)
//ܣ˿ڳʼ
//-------------------------------------------------------------------------------
void IO_Init(void)
{
	;
}

//-------------------------------------------------------------------------------
//ӳ:ResetDateFlow(void)
//ܣλΪһη׼
//˵DIλΪ0ʱԼ65us
//-------------------------------------------------------------------------------
void ResetDataFlow(void)
{
	unsigned char i,j;
	DI=0;					//DIΪ0ʱ50usϣʵ֡λ
	for(i=0;i<15;i++)		//˴33Mhzʱʱ65us
	{
		for(j=0;j<20;j++)
		{
			;
		}
	}
}
//-------------------------------------------------------------------------------
//ӳ:SendOnePix(unsigned char *ptr)
//ܣһص24bit
//յĲһָ룬˺ὫָָĵַByteݷ
//˵ֱӵô˺ʱ֡ͿʼǰҪִ ResetDataFlow()
//		ǰķʽͣΪ800KBPS
//-------------------------------------------------------------------------------
void SendOnePix(unsigned char *ptr)
{
	unsigned char i,j;
	unsigned char temp;

	for(j=0;j<3;j++)
	{
		temp=ptr[j];
		for(i=0;i<8;i++)
		{
			if(temp&0x80)		 //Ӹλʼ
			{
				DI=1;			 //͡1
				_nop_();		 //ʡԵnop(),ʱָʱãƵ33MHz
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();

				DI=0;
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
			}
			else				//͡0
			{
				DI=1;
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();

				DI=0;
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
				_nop_();
			}
			temp=(temp<<1);		 //λ
		}
	}
}
//-------------------------------------------------------------------------------
//ӳ:SendOneFrame(unsigned char *ptr)
//ܣһ֡ݣݣ
//յĲһָ룬˺Ὣָָĵַݷ
//-------------------------------------------------------------------------------
void SendOneFrame(unsigned char *ptr)
{
	unsigned char k;

	ResetDataFlow();				 //֡λź

	for(k=0;k<SNUM;k++)				 //һ֡ݣSNUMǰLEDĸ
	{
		SendOnePix(&ptr[(3*k)]);
	}

	ResetDataFlow();				 //֡λź
}

//-------------------------------------------------------------------------------
//ӳ:SendSameColor(unsigned char *ptr,unsigned char cnt)
//ܣͬɫĵ㷢cnt
//յĲһָ룬ָصɫ飬cntݷ͸
//-------------------------------------------------------------------------------
void SendSameColor(unsigned char *ptr,unsigned char cnt)
{
	unsigned char k;

	ResetDataFlow();				 //֡λź

	for(k=0;k<cnt;k++)				 //һ֡ݣSNUMǰLEDĸ
	{
		SendOnePix(&ptr[0]);
	}

	ResetDataFlow();				 //֡λź
}
//-------------------------------------------------------------------------------
//ӳ:SendOneFrameFrom(unsigned char i,unsigned char *ptr)
//ܣָص㿪ʼһ֡ݣݣ
//յĲһָ룬˺Ὣָָĵַ֡ݷ
//		i:ĵ0ݷ͵iص㣨0ǰϱΪ01أ
//˵ԭӦһصݻᷢ͵iص㣨LED
//-------------------------------------------------------------------------------
void SendOneFrameFrom(unsigned char i,unsigned char *ptr)
{
	unsigned char k;

	ResetDataFlow();				 //֡λź

   	for(k=(SNUM-i);k<SNUM;k++)		 //һ֡
	{
		SendOnePix(&ptr[(3*k)]);
	}
	for(k=0;k<(SNUM-i);k++)
	{
		SendOnePix(&ptr[(3*k)]);
	}

	ResetDataFlow();				 //֡λź
}

//-------------------------------------------------------------------------------
//ӳ:SendOneFrameSince(unsigned char i,unsigned char *ptr)
//ܣӵiصݿʼһ֡ݣݣ
//յĲһָ룬˺Ὣָָĵַ֡ݷ
//		i:ĵiݷ͵1ص
//˵ԭӦiصݻᷢ͵1ص㣨LEDϣi+1ص
//		͵2
//-------------------------------------------------------------------------------
void SendOneFrameSince(unsigned char i,unsigned char *ptr)
{
	unsigned char k;

	ResetDataFlow();				 //֡λź

	for(k=i;k<SNUM;k++)				 //һ֡
	{
		SendOnePix(&ptr[(3*k)]);
	}
	for(k=0;k<i;k++)
	{
		SendOnePix(&ptr[(3*k)]);
	}
	ResetDataFlow();				 //֡λź
}
/**********************************THE END**********************************/ 

 

